///////// FILE INFO /////////

// Include guards
#ifndef CONSTANTS_HPP
#define CONSTANTS_HPP

// Includes I didn't make myself
#include <cmath>
#include <string>

// Includes I did make myself


// Window settings
const int SCR_W = 800;
const int SCR_H = 600;
const std::string SCR_TITLE = "Sharkfest";

// Direction enum
enum Dir {
	DIR_TOP = 0,
	DIR_RIGHT,
	DIR_BOTTOM,
	DIR_LEFT
};

// Player constants
const int PLYR_ROTSPEED = 5;
const int PLYR_MOVSPEED = 4;

// Map constants
// const int MAP_WALLGRIDSIZE = 128;
// const int MAP_PLYRGRIDSIZE = 64;
const int MAP_W = 3600;
const int MAP_H = 3600;
const int BG_WIDTH = 1200;
const int BG_HEIGHT = 900;
const int BG_ALPHA = 180;

// Target constants
const int TRGT_MOVSPEED = 3;
const int TRGT_DONE = 0;
const int TRGT_DESTROY = 1;
const float TRGT_ROTSPEED = M_PI / 100.0;

const int MAX_FISH = 100;

#endif