
// Includes I didn't make myself
	#define _USE_MATH_DEFINES
#include <cmath>
#include <iostream>
#include <SFML/Graphics.hpp>

// Includes I did make myself
#include "constants.hpp"
#include "functions.hpp"

Dir rectDisplace(sf::FloatRect& pos, sf::FloatRect wall) {
    // Deze functie duwt het vierkant buiten het andere vierkant
    // En geeft de kant dat ie 'm opduwt

    Dir direction;

    // Ten opzichte van wall. Dus dt = verschil onderrand speler en bovenrand wall
    float dt = pos.top + pos.height - wall.top;
    float dr = wall.left + wall.width - pos.left;
    float db = wall.top + wall.height - pos.top;
    float dl = pos.left + pos.width - wall.left;

    // if (dt <= dr && dt <= db && dt <= dl) {
        // direction = DIR_TOP;
        // pos.top = wall.top - pos.height;
    // } else if (dr <= dt && dr <= db && dr <= dl) {
        // direction = DIR_RIGHT;
        // pos.left = wall.left + wall.width;
    // } else if (db <= dt && db <= dr && db <= dl) {
        // direction = DIR_BOTTOM;
        // pos.top = wall.top + wall.height;
    // } else if (dl <= dt && dl <= dr && dl <= db) {
        // direction = DIR_LEFT;
        // pos.left = wall.left - pos.width;
    // }
	
	if (dt < dr && dt < db && dt < dl) {
        direction = DIR_TOP;
        pos.top = wall.top - pos.height;
    } else if (dr < db && dr < dl) {
        direction = DIR_RIGHT;
        pos.left = wall.left + wall.width;
    } else if (db < dl) {
        direction = DIR_BOTTOM;
        pos.top = wall.top + wall.height;
    } else {
        direction = DIR_LEFT;
        pos.left = wall.left - pos.width;
    }

    return direction;
}

// Apply rectangle transformation to a rectangleshape (why is there no standard function for this SFML?)
int applyRectToShape(sf::FloatRect pos, sf::RectangleShape& shape) {
	shape.setSize(sf::Vector2f(pos.width, pos.height));
	shape.setPosition(pos.left, pos.top);
	
	return 0;
}

float radToDeg(float a) {
	return a / M_PI * 180;
}

float degToRad(float a) {
	return a / 180.0 * M_PI;
}

int drawRect(sf::RenderWindow& window, sf::IntRect rect, sf::Color clr) {
	sf::RectangleShape r(sf::Vector2f(rect.width, rect.height));
	r.setPosition(rect.left, rect.top);
	r.setFillColor(clr);
	
	window.draw(r);
	
	return 0;
}

float pythagoras(sf::Vector2f s, sf::Vector2f e) {
	return sqrt(pow(e.x - s.x, 2) + pow(e.y - s.y, 2));
}

bool rectContains(sf::FloatRect super, sf::FloatRect sub) {
	if (super.left <= sub.left) {
		if (super.top <= sub.top) {
			if (super.left + super.width >= sub.left + sub.width) {
				if (super.top + super.height >= sub.top + sub.height) return true;
			}
		}
	}
	
	return false;
}

// ax + b = y
// b = y - ax
// x = (y - b) / a
// Vertical start/end lines not working.
// Must be optimized for more box collisions
sf::FloatRect isctLineAABB(sf::Vector2f lStart, sf::Vector2f lEnd, sf::FloatRect aabb) {
	float a = (lEnd.y - lStart.y) / (lEnd.x - lStart.x);
	float b = lEnd.y - a * lEnd.x;
	
	int xs[2] = {aabb.left, aabb.left + aabb.width};
	int ys[2] = {aabb.top, aabb.top + aabb.height};
	
	float x, y;
	
	std::vector<sf::FloatRect> solutions;
	solutions.reserve(4);
	
	// Collision on vertical lines
	for (int i = 0; i < 2; ++i) {
		y = a * (float)xs[i] + b;
		
		if (xs[i] >= fmin(lStart.x, lEnd.x) && xs[i] <= fmax(lStart.x, lEnd.x)) {
			if (y >= fmin(lStart.y, lEnd.y) && y <= fmax(lStart.y, lEnd.y)) {
				if (y >= ys[0] && y <= ys[1]) {
					solutions.push_back(sf::FloatRect(xs[i], y, pythagoras(lStart, sf::Vector2f(xs[i], y)), 1));
				}		
			}
		}
	}
	
	// Collision for horizontal lines
	for (int i = 0; i < 2; ++i) {
		x = (ys[i] - b) / (float)a;
		
		if (ys[i] >= fmin(lStart.y, lEnd.y) && ys[i] <= fmax(lStart.y, lEnd.y)) {
			if (x >= fmin(lStart.x, lEnd.x) && x <= fmax(lStart.x, lEnd.x)) {
				if (x >= xs[0] && x <= xs[1]) {
					solutions.push_back(sf::FloatRect(x, ys[i], pythagoras(lStart, sf::Vector2f(x, ys[i])), 1));
				}
			}
		}
	}
	
	// Pick closest solution
	if (solutions.size() > 0) {
		int s = 0;
		float d = solutions[0].width;
		for (int i = 1; i < solutions.size(); ++i) {
			if (solutions[i].width < d) {
				s = i;
				d = solutions[i].width;
			}
		}
		
		return solutions[s];
	}
	
	// Return a nullRect if no collision
	return sf::FloatRect(0, 0, 0, 0);
}

float toAng(float s, float e, float t) { // Moves to shortest angle
    bool clockwise;
    float d, diff;
    float a, b, c;
    a = e - s;
    b = e - s + 2 * M_PI;
    c = e - s - 2 * M_PI;

    float fa, fb, fc;
    fa = fabs(a);
    fb = fabs(b);
    fc = fabs(c);

    if (fa <= fb && fa <= fc) {
        d = a;
    } else if (fb <= fa && fb <= fc) {
        d = b;
    } else {
        d = c;
    }

    if (d > 0) {
        clockwise = true;
    } else {
        clockwise = false;
    }

    if (!clockwise) {
        if (e < s) { // Counter clockwise
            diff = s - e;
        } else {
            diff = s + (2 * M_PI - e);
        }

        return s - diff * t;
    } else {
        if (s < e) { // Clockwise
            diff = e - s;
            return s + diff * t;
        } else {
            diff = e + (2 * M_PI - s);
            return s + diff * t;
        }
    }
}