// Includes I didn't make myself
#include <iostream>
#include <SFML/Audio.hpp>
#include <SFML/Graphics.hpp>
#include <sstream>
#include <string>

// Includes I did make myself
#include "functions.hpp"
#include "globals.hpp"
#include "gsGame.hpp"	
#include "target.hpp"
#include "targetManager.hpp"

gsGame::gsGame() :	player(),
					map(),
					tm(MAX_FISH) {
	font.loadFromFile("Media/Hobby-of-night.ttf");
	
	score.setFont(font);
	score.setCharacterSize(30);
	score.setString("Score: 0");
	score.setPosition(0, 0);
	
	music.openFromFile("Media/ocean.wav");
	music.setLoop(true);
	music.setVolume(50);
	music.play();
}

gsGame::~gsGame() {
}

int gsGame::events(sf::RenderWindow& window) {
	sf::Event e;
	// Gather events
	while (window.pollEvent(e)) {
		// Close window when [X] is pressed
		if (e.type == sf::Event::Closed) {
			gm.setNextState(STATE_EXIT);
		}
		
		player.events(e);
	}

	return 0;
}

int gsGame::logic(sf::RenderWindow& window) {
	player.logic();
	
	map.logic(player);
	
	tm.logic(player);
	
	std::stringstream ssScore;
	ssScore << "Score: " << MAX_FISH - tm.getScore();
	score.setString(ssScore.str());

	if (tm.victoryp()) {
		gm.setNextState(STATE_WIN);
	}
	
	return 0;
}

int gsGame::render(sf::RenderWindow& window) {
	// Clear screen
	window.clear(sf::Color(0, 105, 148));
	
	// Draw the player
	player.render(window);
	
	tm.render(window);
	
	map.render(window);
	
	window.draw(score);
	
	// Update the screen
	window.display();

	return 0;
}
