// Includes I didn't make myself
#include <iostream>
#include <SFML/Graphics.hpp>

// Includes I did make myself
#include "functions.hpp"
#include "map.hpp"
#include "player.hpp"

Map::Map() {
	water.loadFromFile("Media/water.jpg");
	
	mid.setTexture(water);
	hor.setTexture(water);
	vert.setTexture(water);
	diag.setTexture(water);
	
	mid.setColor(sf::Color(255, 255, 255, BG_ALPHA));
	hor.setColor(sf::Color(255, 255, 255, BG_ALPHA));
	vert.setColor(sf::Color(255, 255, 255, BG_ALPHA));
	diag.setColor(sf::Color(255, 255, 255, BG_ALPHA));
}

Map::~Map() {

}

int Map::logic(Player& player) {
	sf::FloatRect viewport = player.getViewport();
	sf::Vector2f center = player.getPosition();
	
	sf::Vector2i modCenter((int)center.x % BG_WIDTH, (int)center.y % BG_HEIGHT);
	while (modCenter.x < 0) modCenter.x += BG_WIDTH;
	while (modCenter.y < 0) modCenter.y += BG_HEIGHT;
	
	sf::Vector2f midPos(SCR_W / 2 - modCenter.x, SCR_H / 2 - modCenter.y);
	sf::Vector2f vertPos;
	sf::Vector2f horPos;
	sf::Vector2f diagPos;
	
	if (modCenter.x < BG_WIDTH / 2) { // Left
		horPos = sf::Vector2f(midPos.x - BG_WIDTH, midPos.y);
		
		if (modCenter.y < BG_HEIGHT / 2) { // Top Left
			vertPos = sf::Vector2f(midPos.x, midPos.y - BG_HEIGHT);
			diagPos = sf::Vector2f(midPos.x - BG_WIDTH, midPos.y - BG_HEIGHT);
		} else { // Bottom Left
			vertPos = sf::Vector2f(midPos.x, midPos.y + BG_HEIGHT);
			diagPos = sf::Vector2f(midPos.x - BG_WIDTH, midPos.y + BG_HEIGHT);
		}
	} else { // Right
		horPos = sf::Vector2f(midPos.x + BG_WIDTH, midPos.y);
		
		if (modCenter.y < BG_HEIGHT / 2) { // Top right
			vertPos = sf::Vector2f(midPos.x, midPos.y - BG_HEIGHT);
			diagPos = sf::Vector2f(midPos.x + BG_WIDTH, midPos.y - BG_HEIGHT);
		} else { // Bottom right
			vertPos = sf::Vector2f(midPos.x, midPos.y + BG_HEIGHT);
			diagPos = sf::Vector2f(midPos.x + BG_WIDTH, midPos.y + BG_HEIGHT);
		}
	}
	
	mid.setPosition(midPos);
	hor.setPosition(horPos);
	vert.setPosition(vertPos);
	diag.setPosition(diagPos);
	
	return 0;
}

int Map::render(sf::RenderWindow& window) {
	window.draw(mid);
	window.draw(diag);
	window.draw(vert);
	window.draw(hor);
	
	return 0;
}
	