// Includes I did make myself
#include <iostream>
#include <cmath>
#include <SFML/Graphics.hpp>

// Includs I didn't make myself
#include "constants.hpp"
#include "functions.hpp"
#include "player.hpp"
#include "map.hpp"

Player::Player() {
	if (!texturePlayer.loadFromFile("Media/shark.png")) std::cout << "HELP";
	
	spritePlayer.setTexture(texturePlayer);
	spritePlayer.setPosition(SCR_W / 2, SCR_H / 2);
	sf::Vector2u size = texturePlayer.getSize();
	spritePlayer.setOrigin(140, 35);
	
	viewport.width = SCR_W;
	viewport.height = SCR_H;
	viewport.left = SCR_W / 2 * -1;
	viewport.top = SCR_H / 2 * -1;
	
	biteArea.width = 32;
	biteArea.height = 32;
	
	ang = 0;
	
	position = sf::Vector2f(1800, 1800);
}

Player::~Player() {

}

int Player::events(sf::Event e) {
	if (e.type == sf::Event::KeyPressed) {
		switch (e.key.code) {
			case sf::Keyboard::Left:
				dAng = PLYR_ROTSPEED * -1;
				break;
			case sf::Keyboard::Right:
				dAng = PLYR_ROTSPEED;
				break;
			case sf::Keyboard::Up:
				break;
			case sf::Keyboard::Down:
				break;
			case sf::Keyboard::Space:
				break;
			default:
				break;
		}
	} else if (e.type == sf::Event::KeyReleased) {
		switch (e.key.code) {
			case sf::Keyboard::Left:
			case sf::Keyboard::Right:
				dAng = 0;
				break;
			case sf::Keyboard::Space:
				if (!biting) {
					biting = true;
					biteTimer.restart();
				}
				break;
		}
	}
	
	return 0;
}

int Player::logic() {
	// Handle rotation
	ang += dAng;
	if (ang > 360) {
		ang -= 360;
	} else if (ang < 0) {
		ang += 360;
	}
	spritePlayer.setRotation(ang);
	
	// Move forward a bit
	position.x = position.x + cos(degToRad(ang)) * PLYR_MOVSPEED;
	position.y = position.y + sin(degToRad(ang)) * PLYR_MOVSPEED;
	
	// if (position.x > MAP_W) position.x -= MAP_W;
	// if (position.y > MAP_H) position.y -= MAP_H;
	// if (position.x < 0) position.x += MAP_W;
	// if (position.y < 0) position.y += MAP_H;
	
	// Update viewport
	viewport.left = position.x - SCR_W / 2;
	viewport.top = position.y - SCR_H / 2;
	
	// Update bitearea
	sf::Vector2f p(position.x + cos(degToRad(ang)) * 35, position.y + sin(degToRad(ang)) * 35);
	biteArea.left = p.x - 16;
	biteArea.top = p.y - 16;
	
	// Check if biting period is over
	if (biteTimer.getElapsedTime().asMilliseconds() > 100 && biting) {
		biting = false;
	}
	
	return 0;
}

int Player::render(sf::RenderWindow& window) {
	window.draw(spritePlayer);

	return 0;
}

sf::Vector2f Player::getPosition() {
	return position;
}

sf::FloatRect Player::getViewport() {
	return viewport;
}

sf::Vector2f Player::toScreen(sf::Vector2f p) {
	
	return sf::Vector2f(p.x - viewport.left, p.y - viewport.top);
}

bool Player::isBiting() {
	return biting;
}

int Player::biteSuccess() {
	biting = false;
	return 0;
}

sf::FloatRect Player::getBiteRect() {
	return biteArea;
}

	// if (viewport.intersects(obj) || rectContains(viewport, obj)) {
		// return obj;
	// }
	
	// sf::Vector2f size(obj.width, obj.height);
	
	// std::vector<sf::FloatRect> clones;
	// clones.reserve(8);
	
	// clones.push_back(sf::FloatRect(sf::Vector2f(obj.left - MAP_W, obj.top - MAP_H), size)); // Top Left
	// clones.push_back(sf::FloatRect(sf::Vector2f(obj.left, obj.top - MAP_H), size)); // Top Middle
	// clones.push_back(sf::FloatRect(sf::Vector2f(obj.left + MAP_W, obj.top - MAP_H), size)); // Top Right
	// clones.push_back(sf::FloatRect(sf::Vector2f(obj.left - MAP_W, obj.top), size)); // Middle Left
	// clones.push_back(sf::FloatRect(sf::Vector2f(obj.left + MAP_W, obj.top), size)); // Middle Right
	// clones.push_back(sf::FloatRect(sf::Vector2f(obj.left - MAP_W, obj.top + MAP_H), size)); // Bottom Left
	// clones.push_back(sf::FloatRect(sf::Vector2f(obj.left, obj.top + MAP_H), size)); // Bottom Middle
	// clones.push_back(sf::FloatRect(sf::Vector2f(obj.left + MAP_W, obj.top + MAP_H), size)); // Bottom Right
	
	// for (int i = 0; i < 8; ++i) {
		// if (viewport.intersects(clones[i]) || rectContains(viewport, clones[i])) {
			// return clones[i];
		// }
	// }
	
	// return sf::FloatRect(0, 0, 0, 0);
