// Includes I didn't make myself
#include <vector>

// Includes I did make myself
#include "constants.hpp"
#include "target.hpp"
#include "targetManager.hpp"

TargetManager::TargetManager(int amount) {
	fish.loadFromFile("Media/fish.png");
	
	arrow.loadFromFile("Media/arrow.png");
	
	targets.reserve(amount);
	for (int i = 0; i < amount; i++) {
		targets.push_back(Target(fish, arrow));
	}
	
	buffer.loadFromFile("Media/crunch.wav");
	crunch.setBuffer(buffer);
}

TargetManager::~TargetManager() {

}

int TargetManager::logic(Player& player) {
	for (int i = 0; i < targets.size(); ++i) {
		if (targets[i].logic(player, (i == 0 && targets.size() < 11)) == TRGT_DESTROY) {
			targets.erase(targets.begin() + i);
			crunch.stop();
			crunch.play();
		}
	}
	
	return 0;
}

int TargetManager::render(sf::RenderWindow& window) {
	for (int i = 0; i < targets.size(); ++i) {
		targets[i].render(window);
	}
	
	return 0;
}

int TargetManager::getScore() {
	return targets.size();
}

bool TargetManager::victoryp() {
	if (targets.size() == 0) return true;
	
	return false;
}
